<!----------------------------------------------------------------------------------------------------------------------
  --  Plugin Config Editor
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div>
        <BCard class="overflow-hidden" no-body>
            <template #header>
                <div class="plugin-config-header">
                    <h6 class="mt-1 mb-0 me-2">
                        Base Config
                    </h6>
                    <div class="d-flex">
                        <BButton
                            class="me-2"
                            size="sm"
                            @click="setToDefault('base')"
                        >
                            <Fa icon="rotate-left" />
                            Default
                        </BButton>
                        <BButton size="sm" @click="baseConfig = format(baseConfig)">
                            <Fa icon="code" />
                            Reformat
                        </BButton>
                    </div>
                </div>
            </template>
            <Codemirror
                v-model="baseConfig"
                :extensions="cmExtensions"
                :tab-size="4"
            />
        </BCard>
        <BCard class="overflow-hidden mt-3" no-body>
            <template #header>
                <div class="plugin-config-header">
                    <h6 class="mt-1 mb-2 me-2">
                        Environment Config
                    </h6>
                    <BFormSelect
                        id="plugin-env-select"
                        v-model="selectedEnvironmentId"
                        size="sm"
                        class="me-2"
                    >
                        <BFormSelectOption :value="null">
                            Select an environment...
                        </BFormSelectOption>
                        <BFormSelectOption
                            v-for="envStore in environmentConfigs"
                            :key="envStore.envId"
                            :value="envStore.envId"
                        >
                            {{ envStore.envName }}
                        </BFormSelectOption>
                    </BFormSelect>
                    <div class="d-flex">
                        <BButton
                            class="me-2"
                            size="sm"
                            @click="setToDefault('env')"
                        >
                            <Fa icon="rotate-left" />
                            Default
                        </BButton>
                        <BButton size="sm" @click="formatEnv()">
                            <Fa icon="code" />
                            Reformat
                        </BButton>
                    </div>
                </div>
            </template>
            <Codemirror
                v-if="environmentConfigs"
                v-model="environmentConfig"
                :extensions="cmExtensions"
                :tab-size="4"
            />
            <div v-else class="text-center">
                <h5 class="text-center">
                    Please select an environment to edit it's config.
                </h5>
            </div>
        </BCard>
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style lang="scss">
    #plugin-env-select {
        max-width: 200px;
    }

    .plugin-config-header {
        display: flex;
        justify-content: space-between
    }
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { computed, ref, watch } from 'vue';
    import { useObservable } from '../../lib/composables/rxjs.js';
    import { json5, json5ParseLinter } from 'codemirror-json5';
    import { linter } from '@codemirror/lint';
    import { oneDark } from '@codemirror/theme-one-dark';
    import JSON5 from 'json5';

    // Models
    import { SSTClientConfigPopulated } from '../../lib/managers/plugin.js';

    // Resource Access
    import colorMode from '../../lib/resource-access/colorMode';

    // Components
    import { Codemirror } from 'vue-codemirror';

    //------------------------------------------------------------------------------------------------------------------
    // Component Definition
    //------------------------------------------------------------------------------------------------------------------

    interface Props
    {
        configType : 'user' | 'system'
        disabled ?: boolean,
        environments ?: { id : string, name : string }[],
        currentEnvId ?: string,
    }

    const props = withDefaults(defineProps<Props>(), {
        disabled: false,
        environments: () => [],
        currentEnvId: undefined,
    });

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const pluginConfig = defineModel<SSTClientConfigPopulated | null>('pluginConfig', { required: true });

    const baseConfigJSON = ref<string>();
    const selectedEnvironmentId = ref<string | null>(null);
    const baseCMExtensions = [ json5(), linter(json5ParseLinter()) ];

    //------------------------------------------------------------------------------------------------------------------
    // Observables
    //------------------------------------------------------------------------------------------------------------------

    const bsTheme = useObservable(colorMode.bsTheme$);

    //------------------------------------------------------------------------------------------------------------------
    // Computed
    //------------------------------------------------------------------------------------------------------------------

    const storage = computed({
        get()
        {
            return props.configType === 'user'
                ? pluginConfig.value?.userStorage
                : pluginConfig.value?.systemStorage;
        },
        set(val)
        {
            if(pluginConfig.value)
            {
                if(props.configType === 'user')
                {
                    pluginConfig.value.userStorage = val;
                }
                else
                {
                    pluginConfig.value.systemStorage = val;
                }
            }
        },
    });

    const baseConfig = computed({
        get()
        {
            return baseConfigJSON.value;
        },
        set(val)
        {
            // Set json value
            baseConfigJSON.value = val;

            // Set storage value
            const { environments } = storage.value;

            // eslint-disable-next-line no-use-before-define
            const parsedVal = parseJSON5(val);
            if(parsedVal != undefined)
            {
                storage.value = {
                    ...parsedVal,
                    environments,
                };
            }
        },
    });

    const environmentConfigs = computed(() =>
    {
        return Object.keys(storage.value?.environments ?? {}).map((envId) =>
        {
            return {
                envId,
                envName: props.environments.find((env) => env.id === envId)?.name ?? envId,
                // eslint-disable-next-line no-use-before-define
                config: format(JSON.stringify(storage.value?.environments[envId])),
            };
        });
    });

    const selectedEnvironmentConfig = computed(() =>
    {
        return selectedEnvironmentId.value
            ? environmentConfigs.value?.find((envConfig) => envConfig.envId === selectedEnvironmentId.value)
            : undefined;
    });

    const environmentConfig = computed({
        get()
        {
            return selectedEnvironmentConfig.value?.config;
        },
        set(val)
        {
            if(selectedEnvironmentConfig.value)
            {
                selectedEnvironmentConfig.value.config = val;

                // eslint-disable-next-line no-use-before-define
                const parsedVal = parseJSON5(val);
                if(parsedVal !== undefined)
                {
                    storage.value.environments[selectedEnvironmentConfig.value.envId]
                        = parsedVal;
                }
            }
        },
    });

    const cmExtensions = computed(() =>
    {
        if(bsTheme.value === 'dark')
        {
            return [
                ...baseCMExtensions,
                oneDark,
            ];
        }

        return baseCMExtensions;
    });

    //------------------------------------------------------------------------------------------------------------------
    // Methods
    //------------------------------------------------------------------------------------------------------------------

    function format(payload ?: string) : string
    {
        const obj = JSON5.parse(payload ?? '{}');
        const formatted = JSON5.stringify(obj, null, 4);
        if(formatted === '{}')
        {
            return '{\n}';
        }
        return formatted;
    }

    function formatEnv() : void
    {
        if(selectedEnvironmentConfig.value)
        {
            environmentConfig.value = format(environmentConfig.value);
        }
    }

    function setToDefault(mode : 'base' | 'env') : void
    {
        switch (mode)
        {
            case 'base':
                baseConfig.value = format(JSON.stringify(pluginConfig.value?.defaults?.base));
                break;
            case 'env':
                if(selectedEnvironmentConfig.value)
                {
                    environmentConfig.value
                        = format(JSON.stringify(pluginConfig.value?.defaults?.environment));
                }
                break;
        }
    }

    function loadStorage() : void
    {
        if(storage.value)
        {
            const { environments, ...rest } = storage.value;
            baseConfig.value = format(JSON.stringify({ ...rest }));

            selectedEnvironmentId.value = environmentConfigs.value
                .find((envStore) => envStore.envId === props.currentEnvId)?.envId
                ?? environmentConfigs.value[0]?.envId;
        }
    }

    function parseJSON5(val : string) : any
    {
        let returnVal : any = undefined;

        try
        {
            returnVal = JSON5.parse(val);
        }
        catch { /* empty */ }

        return returnVal;
    }

    //------------------------------------------------------------------------------------------------------------------
    // Watchers
    //------------------------------------------------------------------------------------------------------------------

    watch(pluginConfig, () =>
    {
        loadStorage();
    }, { immediate: true });
</script>

<!--------------------------------------------------------------------------------------------------------------------->
